<App>
  <Include src="./functions.rsx" />
  <Frame
    id="$main"
    enableFullBleed={false}
    isHiddenOnDesktop={false}
    isHiddenOnMobile={false}
    padding="8px 12px"
    sticky={null}
    type="main"
  >
    <Module
      id="acmeInventoryModule1"
      name="Acme Inventory Module"
      pageUuid="0dc56770-fe7a-11ee-ab3d-4fb57c0336f1"
    />
    <Table
      id="table1"
      actionsOverflowPosition={1}
      cellSelection="none"
      clearChangesetOnSave={true}
      data="{{ getInventory.data }}"
      defaultSelectedRow={{ mode: "index", indexType: "display", index: 0 }}
      emptyMessage="No rows found"
      enableSaveActions={true}
      groupByColumns={{}}
      limitOffsetRowCount="{{getTableSize.data.count}}"
      overflowType="pagination"
      primaryKeyColumnId="34e15"
      rowHeight="medium"
      serverPaginated={true}
      showBorder={true}
      showFooter={true}
      showHeader={true}
      templatePageSize="10"
      toolbarPosition="bottom"
    >
      <Column
        id="34e15"
        alignment="right"
        editableOptions={{ showStepper: true }}
        format="decimal"
        formatOptions={{ showSeparators: true, notation: "standard" }}
        groupAggregationMode="sum"
        hidden="true"
        key="id"
        label="ID"
        placeholder="Enter value"
        position="center"
        size={100}
      />
      <Column
        id="8d23b"
        alignment="left"
        format="string"
        groupAggregationMode="none"
        key="sku"
        label="SKU"
        placeholder="Enter value"
        position="center"
        size={192}
      />
      <Column
        id="eebcc"
        alignment="left"
        format="string"
        groupAggregationMode="none"
        key="description"
        label="Description"
        placeholder="Enter value"
        position="center"
        size={136}
      />
      <Column
        id="affe1"
        alignment="right"
        editable="true"
        editableOptions={{ showStepper: true }}
        format="decimal"
        formatOptions={{ showSeparators: true, notation: "standard" }}
        groupAggregationMode="sum"
        key="quantity"
        label="Quantity"
        placeholder="Enter value"
        position="center"
        size={124}
        summaryAggregationMode="none"
      />
      <Column
        id="9376e"
        alignment="right"
        editableOptions={{ showStepper: true }}
        format="decimal"
        formatOptions={{ showSeparators: true, notation: "standard" }}
        groupAggregationMode="sum"
        key="replenish"
        label="Replenish"
        placeholder="Enter value"
        position="center"
        size={140}
      />
      <Column
        id="c10c0"
        alignment="left"
        format="tag"
        formatOptions={{
          automaticColors: false,
          color:
            "{{(currentSourceRow.quantity - currentSourceRow.replenish) > 0 ? '#90EE90':'#ffcccb' }}",
        }}
        groupAggregationMode="none"
        label="Delta"
        placeholder="Select option"
        position="center"
        referenceId="delta"
        size={100}
        summaryAggregationMode="none"
        valueOverride="{{currentSourceRow.quantity - currentSourceRow.replenish}}"
      />
      <Column
        id="6354c"
        alignment="left"
        format="tag"
        formatOptions={{ automaticColors: true }}
        groupAggregationMode="none"
        label="Status"
        placeholder="Select option"
        position="center"
        referenceId="status"
        size={100}
        summaryAggregationMode="none"
        valueOverride="{{(currentSourceRow.quantity - currentSourceRow.replenish) > 0 ? 'In Stock' : 'Below Levels'}}"
      />
      <Column
        id="0b04a"
        alignment="left"
        format="tag"
        formatOptions={{ automaticColors: true }}
        groupAggregationMode="none"
        key="location"
        label="Location"
        placeholder="Select option"
        position="center"
        size={100}
        valueOverride="{{ _.startCase(item) }}"
      />
      <Column
        id="9f550"
        alignment="left"
        format="link"
        formatOptions={{ showUnderline: "hover", underlineStyle: "solid" }}
        groupAggregationMode="none"
        label="Place Order"
        placeholder="Enter value"
        position="center"
        referenceId="placeOrder"
        size={100}
        summaryAggregationMode="none"
        valueOverride={
          '{{(currentSourceRow.quantity-currentSourceRow.replenish) < 0 ? "Reorder":""}}'
        }
      >
        <Event
          event="clickCell"
          method="trigger"
          params={{ ordered: [] }}
          pluginId="initiateReorderWorkflow"
          type="datasource"
          waitMs="0"
          waitType="debounce"
        />
      </Column>
      <Action
        id="47e30"
        icon="bold/interface-delete-bin-2"
        label="Delete Inventory"
      >
        <Event
          event="clickAction"
          method="trigger"
          params={{ ordered: [] }}
          pluginId="deleteInventory"
          type="datasource"
          waitMs="0"
          waitType="debounce"
        />
      </Action>
      <ToolbarButton
        id="1a"
        icon="bold/interface-text-formatting-filter-2"
        label="Filter"
        type="filter"
      />
      <ToolbarButton
        id="3c"
        icon="bold/interface-download-button-2"
        label="Download"
        type="custom"
      />
      <ToolbarButton
        id="4d"
        icon="bold/interface-arrows-round-left"
        label="Refresh"
        type="custom"
      />
      <Event
        event="save"
        method="trigger"
        params={{ ordered: [] }}
        pluginId="updateInventory"
        type="datasource"
        waitMs="0"
        waitType="debounce"
      />
    </Table>
    <PlotlyChart
      id="chart1"
      dataseries={{
        ordered: [
          {
            0: {
              ordered: [
                { label: "id" },
                { datasource: "{{getInventory.data['id']}}" },
                { chartType: "bar" },
                { aggregationType: "sum" },
                { color: "#1E3A8A" },
                { colors: { ordered: [] } },
                { visible: false },
                {
                  hovertemplate:
                    "<b>%{x}</b><br>%{fullData.name}: %{y}<extra></extra>",
                },
              ],
            },
          },
          {
            1: {
              ordered: [
                { label: "quantity" },
                { datasource: "{{getInventory.data['quantity']}}" },
                { chartType: "bar" },
                { aggregationType: "sum" },
                { color: "#3170F9" },
                { colors: { ordered: [] } },
                { visible: true },
                {
                  hovertemplate:
                    "<b>%{x}</b><br>%{fullData.name}: %{y}<extra></extra>",
                },
              ],
            },
          },
          {
            2: {
              ordered: [
                { label: "replenish" },
                { datasource: "{{getInventory.data['replenish']}}" },
                { chartType: "bar" },
                { aggregationType: "sum" },
                { color: "#60A5FA" },
                { colors: { ordered: [] } },
                { visible: true },
                {
                  hovertemplate:
                    "<b>%{x}</b><br>%{fullData.name}: %{y}<extra></extra>",
                },
              ],
            },
          },
        ],
      }}
      datasourceDataType="object"
      datasourceInputMode="javascript"
      datasourceJS="{{getInventory.data}}"
      isDataTemplateDirty={true}
      legendAlignment="left"
      skipDatasourceUpdate={true}
      title="Acme Part Inventory"
      xAxis="{{getInventory.data.sku}}"
      xAxisDropdown="sku"
      xAxisTitle="SKU"
    />
  </Frame>
</App>
